#%%global snapdate 20090125

%global pkg_name gtk2hs
%global ghc_version 6.10.1

%global pkg_libdir %{_libdir}/ghc-%{ghc_version}/%{pkg_name}-%{version}
%global pkg_docdir %{_docdir}/ghc/libraries/%{pkg_name}

%bcond_without docs
%bcond_without prof

%bcond_without cairo
%bcond_without svgcairo
%bcond_without gio
%bcond_without opengl
%bcond_without gstreamer

%bcond_with gnomevfs
%bcond_with mozembed

# ghc does not emit debug information
%global debug_package %{nil}

%global common_descr \
A Gtk+ binding for the functional language Haskell featuring automatic memory\
management, unicode support, and wide coverage of Gtk+ 2 widgets.

Summary:        Haskell binding for gtk2 and related libraries
Name:           ghc-gtk2hs
Version:        0.10.0
Release:        4%{?snapdate:.%{snapdate}}%{?dist}
# cairo/ and svgcairo/ are FreeBSD
# compat/ is BSD
# tools/c2hs (used to build) is GPLv2+, LGPLv2+
# except tools/c2hs/base/general/{Binary.hs,FastMutInt.hs} from ghc (BSD)
# gstreamer, gio, gnomevfs are LGPLv3
# rest is all LGPLv2+
License:        LGPLv2+ and LGPLv3
Group:          Development/Libraries
%if %{?snapdate:1}0
# snapshot tarball obtained by
#  darcs get --partial http://code.haskell.org/gtk2hs/
#  cd gtk2hs ; darcs dist darcs dist --dist-name=gtk2hs-%{snapdate}
Source:         %{pkg_name}-%{version}%{?snapdate:-%{snapdate}}.tar.gz
%else
Source:         http://prdownloads.sourceforge.net/%{pkg_name}/%{pkg_name}-%{version}.tar.gz
%endif
URL:            http://gtk2hs.sourceforge.net/
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
# fedora ghc archs:
ExclusiveArch:  %{ix86} x86_64 ppc alpha
BuildRequires:  ghc = %{ghc_version}
BuildRequires:  happy, alex
%if %{with docs}
BuildRequires:  haddock >= 2.4.1
BuildRequires:  ghc-doc = %{ghc_version}
%endif
%if %{with prof}
BuildRequires:  ghc-prof = %{ghc_version}
%endif
BuildRequires:  gtk2-devel
BuildRequires:  gtksourceview2-devel
BuildRequires:  libglade2-devel
BuildRequires:  GConf2-devel, dbus-devel
%if %{with gstreamer}
BuildRequires:  gstreamer-devel, gstreamer-plugins-base-devel
%endif
%if %{with mozembed}
BuildRequires:  xulrunner-devel
%endif
%if %{with cairo}
BuildRequires:  cairo-devel
%if %{with svgcairo}
BuildRequires:  librsvg2-devel
%endif
%endif
%if %{with opengl}
BuildRequires:  gtkglext-devel
%endif

%description
%commom_descr

This package also includes the bindings for cairo, gconf, glade, glib, and
sourceview.  The libraries are compiled for ghc-%{ghc_version}.


# added for F11, can be dropped for F13
%package compat
Summary:        Haskell Gtk+ GUI library backward compatibility
Group:          Development/Libraries
# ditto
Provides:       %{name} = %{version}-%{release}
Obsoletes:      %{name} < 0.10.0
# ghc682 is from f8
Obsoletes:      ghc661-%{pkg_name}, ghc682-%{pkg_name}
Obsoletes:      ghc661-%{pkg_name}-mozembed, ghc682-%{pkg_name}-mozembed
# these 3 pull in the others
Requires:       ghc-gconf-devel = %{version}-%{release}
Requires:       ghc-glade-devel = %{version}-%{release}
Requires:       ghc-soegtk-devel = %{version}-%{release}

%description compat
%common_descr

This package obsoletes the former ghc-gtk2hs package and can safely be removed.


%package common
Summary:        Haskell Gtk+ GUI library common files
Group:          Development/Libraries

%description common
%common_descr

This package contains some common files shared by the subpackages.


%if %{with docs}
%package doc
Summary:        Haskell Gtk+ GUI library documentation
Group:          Development/Libraries
Obsoletes:      gtk2hs-doc < 0.9.13-3

%description doc
%common_descr

This package contains the gtk2hs documentation.
%endif


# subpackage name lib [dep] [obsoletes]
%define subpackage()\
%package -n ghc-%1-devel\
Summary:        Haskell binding for %1\
Group:          Development/Libraries\
Requires:       ghc = %{ghc_version}\
Requires:       %{name}-common = %{version}-%{release}\
Requires:       %2-devel, %{?3:ghc-%3-devel = %{version}-%{release}}\
Requires(post): %{_bindir}/ghc-pkg-%{ghc_version}\
Requires(preun): %{_bindir}/ghc-pkg-%{ghc_version}\
# added for F11\
Obsoletes:      ghc-%1 < 0.10.0-3\
%{?4:Obsoletes:      %4 < 0.10.0}\
\
%description -n ghc-%1-devel\
%common_descr\
\
This package contains a Haskell binding of the %1 library.\
\
%if %{with prof}\
%package -n ghc-%1-prof\
Summary:        Haskell %1 profiling library\
Group:          Development/Libraries\
Requires:       ghc-prof = %{ghc_version}\
Requires:       ghc-%1-devel = %{version}-%{release}\
\
%description -n ghc-%1-prof\
%common_descr\
\
This package contains the profiling libraries for the Haskell %1 library.\
%endif\
\
%post -n ghc-%1-devel\
ghc-pkg-%{ghc_version} update %{pkg_libdir}/%1.package.conf &>/dev/null || : \
\
%preun -n ghc-%1-devel\
if [ "$1" = 0 ]; then\
  ghc-pkg-%{ghc_version} unregister %1-%{version} &>/dev/null || : \
fi\
\
%files -n ghc-%1-devel\
%defattr(-,root,root,-)\
%{pkg_libdir}/%1.cabal\
%{pkg_libdir}/%1.package.conf\
%{pkg_libdir}/libHS%1.a\
%{pkg_libdir}/HS%1.o\
%{pkg_libdir}/imports/%1\
\
%if %{with prof}\
%files -n ghc-%1-prof\
%defattr(-,root,root,-)\
%{pkg_libdir}/libHS%{1}_p.a\
%endif

%subpackage cairo cairo glib
%subpackage gconf GConf2 glib
%if %{with gio}
%subpackage gio glib2 glib
%endif
%subpackage glade libglade2 gtk
%subpackage glib glib2
%if %{with gnomevfs}
%subpackage gnomevfs gnomevfs glib
%endif
%if %{with gstreamer}
%subpackage gstreamer gstreamer glib
%endif
%subpackage gtk gtk2 cairo
%if %{with opengl}
%subpackage gtkglext gtkglext gtk ghc-gtk2hs-gtkglext
%endif
%subpackage gtksourceview2 gtksourceview2 gtk
%if %{with mozembed}
%subpackage mozembed xulrunner gtk
%endif
%subpackage soegtk gtk2 gtk
%subpackage svgcairo librsvg2 cairo

%prep
%if %{?snapdate:1}0
%setup -q -n %{pkg_name}-%{version}-%{snapdate}
%else
%setup -q -n %{pkg_name}-%{version}
%endif
%{?snapdate:autoreconf}


%build
%if %{with docs}
export HADDOCK=%{_bindir}/haddock-2.4.1
%endif
%configure \
        --with-hc=ghc-%{ghc_version} \
        --enable-packager-mode \
%if %{with docs}
        --enable-docs \
%endif
%if %{with prof}
        --enable-profiling \
%endif
	--enable-gio \
	--enable-gtk \
        --enable-libglade \
        --enable-gconf \
        --enable-gstreamer \
        --enable-gtksourceview2 \
%if %{with mozembed}
        --enable-xulrunner \
%endif
%if %{with opengl}
        --enable-opengl \
%endif
%if %{with cairo}
        --enable-cairo \
%if %{with svgcairo}
	--enable-svg \
%endif
%endif
%{nil}

# C locale to workaround c2hs failing in CJK locale
LANG=C make all pkglibdir=%{pkg_libdir} htmldocdir=%{pkg_docdir}


%install
rm -rf %{buildroot}
make install DESTDIR=%{buildroot} pkglibdir=%{pkg_libdir} htmldocdir=%{pkg_docdir}


%clean
rm -rf %{buildroot}


%if %{with docs}
%post doc
%ghc_reindex_haddock

%postun doc
%ghc_reindex_haddock
%endif


%files compat
%defattr(-,root,root,-)


%files common
%defattr(-,root,root,-)
%doc AUTHORS COPYING*
%dir %{pkg_libdir}
%dir %{pkg_libdir}/imports
%dir %{pkg_libdir}/include
%{pkg_libdir}/include/gtk2hs-config.h


%if %{with docs}
%files doc
%defattr(-,root,root,-)
%doc ChangeLog TODO demo
%{pkg_docdir}
%endif


%changelog
* Tue Apr 14 2009 Jens Petersen <petersen@redhat.com> - 0.10.0-4
- use define not global to define subpackage since it broke ?3: expansion
- require the subpackage dependency with -devel suffix

* Mon Mar  9 2009 Jens Petersen <petersen@redhat.com> - 0.10.0-3
- use global
- update arch list
- rename library subpackages to devel and obsolete old packages
- add prof subpackages

* Tue Feb 24 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.10.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Thu Feb 12 2009 Jens Petersen <petersen@redhat.com> - 0.10.0-1
- rebuild for official 0.10.0 release

* Sat Feb  7 2009 Jens Petersen <petersen@redhat.com> - 0.10.0-0.1
- update to 0.10.0 prerelease
- adds .cabal files
- gstreamer, gio, gnomevfs  are LGPLv3
- subpackage all the ghc packages
- add compat and common packages for upgrades
- gtksourceview2 replaces sourceview
- fix docs bcond, and add bcond for svgcairo, gio, gstreamer, prof, and gnomevfs
- build svgcairo and gstreamer
- use common_descr for descriptions

* Fri Feb  6 2009 Jens Petersen <petersen@redhat.com> - 0.9.13-8.20081108
- use bcond

* Wed Dec 17 2008 Jens Petersen <petersen@redhat.com> - 0.9.13-7.20081108
- turn on docs and buildrequire ghc-doc
- buildrequire dbus-devel for gconf private

* Fri Dec  5 2008 Jens Petersen <petersen@redhat.com> - 0.9.13-6.20081108
- install the .o files at build time rather than generating them at install
  (reported by Gregory Weber, #250767)
- update docs building to haddock 2.4.1

* Sun Nov  9 2008 Jens Petersen <petersen@redhat.com> - 0.9.13-5.20081108
- gtk2hs was renamed to ghc-gtk2hs (#468314)
- update to snapshot of darcs tip which builds with ghc-6.10.1
- disable docs for now since haddock-2.2 cannot handle them
- add some snapshot logic
- buildrequires happy and alex
- gtk2hs-fasm-0.9.13.patch is no longer needed

* Fri Nov 07 2008 Bryan O'Sullivan <bos@serpentine.com> - 0.9.13-4
- Rebuild for GHC 6.10.1

* Fri Oct 24 2008 Jens Petersen <petersen@redhat.com> - 0.9.13-3
- install docs in ghc haddock dir with htmldocdir and use ghc_reindex_haddock
- rename gtk2hs-doc to ghc-gtk2hs-doc
- use pkg_name, pkg_libdir, and pkg_docdir for Haskell packaging guidelines
- don't override __spec_install_post

* Mon Jul 14 2008 Bryan O'Sullivan <bos@serpentine.com> - 0.9.13-2
- Try to fix ppc build due to ghc 6.8.3 -fvia-C bug

* Mon Jul 14 2008 Bryan O'Sullivan <bos@serpentine.com> - 0.9.13-1
- Update to 0.9.13

* Mon Jun 23 2008 Jens Petersen <petersen@redhat.com> - 0.9.12.1-10.fc10
- build with ghc-6.8.3
- add build_docs switch
- use haddock09 to fix build failure (#440493)
- merge ghcver subpackage into ghc subpackage in line with ghc
- obsolete old ghcver packages
- add opengl gtkglext subpackage (Ian Collier, #327541)
- require xulrunner-devel instead of firefox-devel
- update prereq's to script requires

* Mon Feb 18 2008 Fedora Release Engineering <rel-eng@fedoraproject.org> - 0.9.12.1-9
- Autorebuild for GCC 4.3

* Thu Dec 13 2007 Bryan O'Sullivan <bos@serpentine.com> - 0.9.12.1-7
* Fix typo

* Thu Dec 13 2007 Bryan O'Sullivan <bos@serpentine.com> - 0.9.12.1-7
* Build with ghc 6.8.2

* Fri Nov 23 2007 Bryan O'Sullivan <bos@serpentine.com> - 0.9.12.1-6
* Exclude alpha

* Fri Nov 09 2007 Bryan O'Sullivan <bos@serpentine.com> - 0.9.12.1-5
* Bump revision number

* Wed Nov 07 2007 Bryan O'Sullivan <bos@serpentine.com> - 0.9.12.1-4
* Revert to 0.9.12 spec file

* Thu Aug 16 2007 Jens Petersen <petersen@redhat.com>
- update License field

* Fri Jul 27 2007 Bryan O'Sullivan <bos@serpentine.com> - 0.9.12-1
- update to 0.9.12 release

* Thu May 10 2007 Bryan O'Sullivan <bos@serpentine.com> - 0.9.11-4
- disable ppc64 build (#239752)

* Thu May 10 2007 Bryan O'Sullivan <bos@serpentine.com> - 0.9.11-3
- rebuild against ghc 6.6.1

* Tue Apr 10 2007 Jens Petersen <petersen@redhat.com> - 0.9.11-2
- obsolete mozembed when it is not built

* Thu Mar 22 2007 Jens Petersen <petersen@redhat.com> - 0.9.11-1
- update to 0.9.11 release
- disable mozembed for now since the firefox minor version keeps changing
  (#223880)

* Thu Nov 16 2006 Jens Petersen <petersen@redhat.com> - 0.9.10.2-0.1
- update to latest darcs snapshot for ghc66
- add soegtk and remove mogul ghc packages

* Thu Sep 28 2006 Jens Petersen <petersen@redhat.com> - 0.9.10-4
- rebuild for FC6

* Sun Aug 20 2006 Jens Petersen <petersen@redhat.com> - 0.9.10-3
- drop explicit firefox-devel version to avoid rebuild every time it changes
  (cf #202395)

* Wed Aug  2 2006 Jens Petersen <petersen@redhat.com> - 0.9.10-2
- mozilla-devel is now firefox-devel

* Mon May 15 2006 Jens Petersen <petersen@redhat.com> - 0.9.10-1
- rework packaging to keep all the ghc packages together except mozembed
- update mozilla version to 1.7.13

* Mon May  1 2006 Gérard Milmeister <gemi@bluewin.ch>
- spec file cleanup
- ghost the .o files generated at install time
- move the docs to a versioned dir and include the demos
- make all subpackages own %%{_libdir}/ghc

* Tue Apr 25 2006 Jens Petersen <petersen@redhat.com>
- use module names for the subpackages
- subpackage mogul
- own the include dir

* Sat Apr 22 2006 Jens Petersen <petersen@redhat.com>
- initial packaging for Fedora Extras
- define ghcpkg_inst and ghcpkg_uninst for post and preun scripts and
  silence ghc-pkg
- own include/

* Wed Oct 26 2005 Jens Petersen <petersen@redhat.com> - 0.9.9.7-0
- rc

* Wed Sep 21 2005 Jens Petersen <petersen@redhat.com> - 0.9.9-2
- build with ghc-6.4.1

* Sat Jul 30 2005 Jens Petersen <petersen@redhat.com> - 0.9.8-3
- drop old conflicts

* Tue Jul  5 2005 Jens Petersen <petersen@redhat.com> - 0.9.8-2
- use %%configure to configure for arch to avoid gclosure ghci-6.4 linking
  problems on i386

* Wed Jun 22 2005 Jens Petersen <petersen@haskell.org> - 0.9.8-1
- update to 0.9.8
- use new --enable-packager-mode and --enable-* configure options

* Thu Jun  9 2005 Jens Petersen <petersen@haskell.org> - 0.9.7.91
- update to rc1
- add build_mozembed macro and use it

* Mon May  9 2005 Jens Petersen <petersen@haskell.org> - 0.9.7-2
- add gtk2hs-0.9.7-ghc64.patch and build with ghc-6.4 (Duncan Coutts)
  - .pkg files are now .cabal files

* Tue Jan 18 2005 Duncan Coutts <duncan@coutts.uklinux.net>
- cleanup requirements, summaries, descriptions, and configure invocation
- update preun scripts

* Thu Aug 19 2004 Jens Petersen <petersen@haskell.org>
- use suffix -ghc621 instead of -ghc6.2.1 and conflict with old packages
- buildrequire ghc-doc and gtk2hs-doc-ghc621 requires ghc-doc
- move docs and demo files to %{_defaultdocdir}/gtk2hs

* Mon Aug 16 2004 Jens Petersen <petersen@haskell.org>
- update to 0.9.6

* Thu Jul 22 2004 Jens Petersen <petersen@haskell.org>
- split sourceview and glade into separate subpackages
- require -devel packages rather than lib pkg for gtk2, gtksourceview,
  and libglade2

* Wed Mar 24 2004 Jens Petersen <petersen@haskell.org>
- enable gtksourceview and glade configure options
- use mkdir -p instead of mkdirhier
- update file locations in %%post and %%preun scripts
- buildrequire libglade2-devel

* Tue Nov 11 2003 Jens Petersen <petersen@haskell.org>
- use %%c2hs instead of "--with c2hs" to configure c2hs program
- clean demo to avoid binary files in docs dir

* Mon Nov  3 2003 Jens Petersen <petersen@haskell.org>
- add sourceview package to %%post and %%preun
- install gtksourceview haskell.lang language-spec

* Thu Jul 31 2003 Jens Petersen <petersen@haskell.org>
- build with ghc-6.0.1
- put demo dir in docs dir rather than individual source files

* Thu Jul 10 2003 Jens Petersen <petersen@haskell.org>
- build with ghc-6.0
- name ghc subpackage "ghc%%{ghc_version}"

* Wed Jun 18 2003 Jens Petersen <petersen@haskell.org>
- require and buildrequire %{_bindir}/ghc-%%{ghc_version}

* Wed May 21 2003 Jens Petersen <petersen@haskell.org>
- add -g option to ghc-pkg -u so that ghci object gets generated
- delete them when uninstalling
- build and include mogul documentation

* Thu May 15 2003 Jens Petersen <petersen@haskell.org>
- use new DESTDIR make variable, so no longer need to fix config files in post
- remove buildroot before install
- build and include gtk docs

* Fri Jan 10 2003 Jens Petersen <petersen@haskell.org>
- made into .spec.in file
- let configure set the version
- update description
- introduce --with-c2hs rpmbuild option
- use perl to remove buildroot traces from package conf files
- simplify ghc-pkg update commands

* Tue Dec 17 2002 Jens Petersen <petersen@haskell.org>
- latest cvs with ghc 5.04.2

* Thu Sep 26 2002 Jens Petersen
- build with ghc-5.04.1

* Fri Aug  2 2002 Jens Petersen
- only include demo source in doc dir

* Fri Jul 26 2002 Jens Petersen
- build with ghc-5.04
- cvs update

* Wed Jul 10 2002 Jens Petersen
- my current branch

* Wed May  1 2002 Jens Petersen
- patch TreeViewColumn.chs to make it usable

* Tue Apr 23 2002 Jens Petersen
- 0.9.0
- update gtk2 and mogul ghc-pkg entries on upgrade

* Fri Apr 12 2002 Jens Petersen
- adapt for gtk2hs
- fix mk files for buildroot install
- post and postun scriptlets for pkg config

* Tue Mar 12 2002 Manuel Chakravarty
- require a specific Haskell compiler (namely, the one for which the packages 
  was compiled)

* Sat Feb 17 2001 Manuel Chakravarty
- derived from C->Haskell's .spec file
